Index: plugins/tools/tool_perspectivetransform/kis_tool_perspectivetransform.cc
===================================================================
--- plugins/tools/tool_perspectivetransform/kis_tool_perspectivetransform.cc	(revision 1177751)
+++ plugins/tools/tool_perspectivetransform/kis_tool_perspectivetransform.cc	(working copy)
@@ -162,7 +162,6 @@
     m_handleHalfSize = 8;
     m_handleSize = 2 * m_handleHalfSize;
     m_handleSelected = NOHANDLE;
-    m_drawing = false;
 }
 
 KisToolPerspectiveTransform::~KisToolPerspectiveTransform()
@@ -312,13 +311,16 @@
 
 void KisToolPerspectiveTransform::mousePressEvent(KoPointerEvent *event)
 {
-    if (image()) {
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
+
+        setMode(KisTool::PAINT_MODE);
+
         switch (m_interractionMode) {
         case DRAWRECTINTERRACTION: {
             m_currentPt = convertToPixelCoord(event);
 
             if (m_points.isEmpty()) {
-                m_drawing = true;
                 m_hasMoveAfterFirstTime = false;
                 m_points.append(m_currentPt);
             } else {
@@ -330,7 +332,7 @@
             break;
         }
         case EDITRECTINTERRACTION: {
-            if (currentImage() && currentNode()->paintDevice() && event->button() == Qt::LeftButton) {
+            if (currentImage() && currentNode()->paintDevice()) {
                 m_actualyMoveWhileSelected = false;
                 m_dragEnd = convertToPixelCoord(event);
                 QPoint mousep = m_dragEnd.toPoint();
@@ -372,93 +374,98 @@
             }
         }
         }
+
     }
+    else {
+        KisTool::mousePressEvent(event);
+    }
 }
 
 void KisToolPerspectiveTransform::mouseMoveEvent(KoPointerEvent *event)
 {
-    switch (m_interractionMode) {
-    case DRAWRECTINTERRACTION: {
-        if (m_drawing) {
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
+
+        switch (m_interractionMode) {
+        case DRAWRECTINTERRACTION: {
             // erase old lines on canvas
             updateCanvasPixelRect(image()->bounds());
-
             // update current point
             m_currentPt = convertToPixelCoord(event);
-
             // draw new lines on canvas
             updateCanvasPixelRect(image()->bounds());
+            break;
         }
-        break;
-    }
 
-    case EDITRECTINTERRACTION: {
-        if (m_currentSelectedPoint) {
-            updateCanvasPixelRect(image()->bounds());
-            QPointF translate = convertToPixelCoord(event) - m_dragEnd;
-            m_dragEnd = convertToPixelCoord(event);
-            *m_currentSelectedPoint += translate;
-            updateCanvasPixelRect(image()->bounds());
-            m_actualyMoveWhileSelected = true;
-        } else if (m_handleSelected == TOPHANDLE || m_handleSelected == LEFTHANDLE || m_handleSelected == BOTTOMHANDLE || m_handleSelected == RIGHTHANDLE) {
-            updateCanvasPixelRect(image()->bounds());
+        case EDITRECTINTERRACTION: {
+            if (m_currentSelectedPoint) {
+                updateCanvasPixelRect(image()->bounds());
+                QPointF translate = convertToPixelCoord(event) - m_dragEnd;
+                m_dragEnd = convertToPixelCoord(event);
+                *m_currentSelectedPoint += translate;
+                updateCanvasPixelRect(image()->bounds());
+                m_actualyMoveWhileSelected = true;
+            } else if (m_handleSelected == TOPHANDLE || m_handleSelected == LEFTHANDLE || m_handleSelected == BOTTOMHANDLE || m_handleSelected == RIGHTHANDLE) {
+                updateCanvasPixelRect(image()->bounds());
 
-            QPointF translate = convertToPixelCoord(event) - m_dragEnd;
-            m_dragEnd = convertToPixelCoord(event);
+                QPointF translate = convertToPixelCoord(event) - m_dragEnd;
+                m_dragEnd = convertToPixelCoord(event);
 
-            switch (m_handleSelected) {
-            case TOPHANDLE:
+                switch (m_handleSelected) {
+                case TOPHANDLE:
+                    m_topleft += translate;
+                    m_topright += translate;
+                    break;
+                case LEFTHANDLE:
+                    m_topleft += translate;
+                    m_bottomleft += translate;
+                    break;
+                case BOTTOMHANDLE:
+                    m_bottomleft += translate;
+                    m_bottomright += translate;
+                    break;
+                case RIGHTHANDLE:
+                    m_topright += translate;
+                    m_bottomright += translate;
+                    break;
+                case MIDDLEHANDLE:
+                case NOHANDLE:
+                    dbgPlugins << "Should NOT happen";
+                }
+
+                updateCanvasPixelRect(image()->bounds());
+                m_actualyMoveWhileSelected = true;
+            } else if (m_handleSelected == MIDDLEHANDLE) {
+                updateCanvasPixelRect(image()->bounds());
+                QPointF translate = convertToPixelCoord(event) - m_dragEnd;
+                m_dragEnd = convertToPixelCoord(event);
                 m_topleft += translate;
                 m_topright += translate;
-                break;
-            case LEFTHANDLE:
-                m_topleft += translate;
                 m_bottomleft += translate;
-                break;
-            case BOTTOMHANDLE:
-                m_bottomleft += translate;
                 m_bottomright += translate;
-                break;
-            case RIGHTHANDLE:
-                m_topright += translate;
-                m_bottomright += translate;
-                break;
-            case MIDDLEHANDLE:
-            case NOHANDLE:
-                dbgPlugins << "Should NOT happen";
+
+                updateCanvasPixelRect(image()->bounds());
+                m_actualyMoveWhileSelected = true;
             }
-
-            updateCanvasPixelRect(image()->bounds());
-            m_actualyMoveWhileSelected = true;
-        } else if (m_handleSelected == MIDDLEHANDLE) {
-            updateCanvasPixelRect(image()->bounds());
-            QPointF translate = convertToPixelCoord(event) - m_dragEnd;
-            m_dragEnd = convertToPixelCoord(event);
-            m_topleft += translate;
-            m_topright += translate;
-            m_bottomleft += translate;
-            m_bottomright += translate;
-
-            updateCanvasPixelRect(image()->bounds());
-            m_actualyMoveWhileSelected = true;
         }
+        }
     }
+    else {
+        KisTool::mouseMoveEvent(event);
     }
 }
 
 void KisToolPerspectiveTransform::mouseReleaseEvent(KoPointerEvent * event)
 {
-    if (!currentImage())
-        return;
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
 
-    if (event->button() == Qt::LeftButton) {
         switch (m_interractionMode) {
         case DRAWRECTINTERRACTION: {
-            if (m_drawing && event->button() == Qt::LeftButton && m_hasMoveAfterFirstTime)  {
+            if (m_hasMoveAfterFirstTime)  {
                 updateCanvasPixelRect(image()->bounds());
 
                 m_points.append(m_currentPt);
-                
+
                 if(m_points.size() == 4) {
                     QPolygonF polygon;
                     polygon << m_points[0] << m_points[1] << m_points[2] << m_points[3];
@@ -469,8 +476,8 @@
                         setStatusText(QString());
                     }
                 }
-                
 
+
                 if (m_points.size() == 4) {
                     // from the points, select which is topleft ? topright ? bottomright ? and bottomleft ?
                     orderHandles();
@@ -518,6 +525,9 @@
         }
         }
     }
+    else {
+        KisTool::mouseReleaseEvent(event);
+    }
 }
 
 void KisToolPerspectiveTransform::paintOutline()
Index: plugins/tools/tool_grid/kis_tool_grid.cc
===================================================================
--- plugins/tools/tool_grid/kis_tool_grid.cc	(revision 1177751)
+++ plugins/tools/tool_grid/kis_tool_grid.cc	(working copy)
@@ -37,7 +37,6 @@
 {
     Q_ASSERT(m_canvas);
     setObjectName("tool_grid");
-    m_dragging = false;
 }
 
 KisToolGrid::~KisToolGrid()
@@ -60,26 +59,34 @@
 
 void KisToolGrid::mousePressEvent(KoPointerEvent *event)
 {
-    m_dragging = true;
-    m_dragStart = convertToPixelCoord(event);
-    KisConfig cfg;
-    if (event->modifiers() == Qt::ControlModifier) {
-        m_currentMode = SCALE;
-    } else {
-        m_currentMode = TRANSLATION;
-    }
+    if(PRESS_CONDITION_OM(event, KisTool::HOVER_MODE,
+                          Qt::LeftButton, Qt::ControlModifier)) {
 
-    if (m_currentMode == TRANSLATION) {
-        m_initialOffset = QPoint(cfg.getGridOffsetX(), cfg.getGridOffsetY());
-    } else {
-        m_initialSpacing = QPoint(cfg.getGridHSpacing(), cfg.getGridVSpacing());
+        setMode(KisTool::PAINT_MODE);
+
+        m_dragStart = convertToPixelCoord(event);
+        KisConfig cfg;
+        if (event->modifiers() == Qt::ControlModifier) {
+            m_currentMode = SCALE;
+        } else {
+            m_currentMode = TRANSLATION;
+        }
+
+        if (m_currentMode == TRANSLATION) {
+            m_initialOffset = QPoint(cfg.getGridOffsetX(), cfg.getGridOffsetY());
+        } else {
+            m_initialSpacing = QPoint(cfg.getGridHSpacing(), cfg.getGridVSpacing());
+        }
     }
+    else {
+        KisTool::mousePressEvent(event);
+    }
 }
 
 
 void KisToolGrid::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (m_dragging) {
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
         KisConfig cfg;
         int subdivisions = cfg.getGridSubdivisions();
         m_dragEnd = convertToPixelCoord(event);
@@ -93,15 +100,20 @@
             if (newSize.y() >= 1) cfg.setGridVSpacing(newSize.y());
         }
         m_canvas->updateCanvas();
-    } else {
-        event->ignore();
     }
+    else {
+        KisTool::mouseMoveEvent(event);
+    }
 }
 
 void KisToolGrid::mouseReleaseEvent(KoPointerEvent *event)
 {
-    Q_UNUSED(event);
-    m_dragging = false;
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
+    }
+    else {
+        KisTool::mouseReleaseEvent(event);
+    }
 }
 
 void KisToolGrid::paint(QPainter& gc, const KoViewConverter &converter)
Index: plugins/tools/tool_grid/kis_tool_grid.h
===================================================================
--- plugins/tools/tool_grid/kis_tool_grid.h	(revision 1177751)
+++ plugins/tools/tool_grid/kis_tool_grid.h	(working copy)
@@ -55,7 +55,6 @@
     QPoint m_initialSpacing;
 
     Mode m_currentMode;
-    bool m_dragging;
 };
 
 
Index: plugins/tools/tool_perspectivegrid/kis_tool_perspectivegrid.cc
===================================================================
--- plugins/tools/tool_perspectivegrid/kis_tool_perspectivegrid.cc	(revision 1177751)
+++ plugins/tools/tool_perspectivegrid/kis_tool_perspectivegrid.cc	(working copy)
@@ -51,8 +51,6 @@
 {
     Q_ASSERT(m_canvas);
     setObjectName("tool_perspectivegrid");
-
-    m_drawing = false;
 }
 
 KisToolPerspectiveGrid::~KisToolPerspectiveGrid()
@@ -65,10 +63,10 @@
 
     m_canvas->view()->perspectiveGridManager()->startEdition();
     if (! m_canvas->view()->resourceProvider()->currentImage()->perspectiveGrid()->hasSubGrids()) {
-        m_mode = MODE_CREATION;
+        m_internalMode = MODE_CREATION;
         m_points.clear();
     } else {
-        m_mode = MODE_EDITING;
+        m_internalMode = MODE_EDITING;
         useCursor(KisCursor::arrowCursor());
         m_canvas->view()->perspectiveGridManager()->setVisible(true);
         m_canvas->updateCanvas(); // TODO only the correct rect
@@ -78,9 +76,8 @@
 void KisToolPerspectiveGrid::deactivate()
 {
     m_canvas->view()->perspectiveGridManager()->stopEdition();
-    if (m_mode == MODE_CREATION) {
+    if (m_internalMode == MODE_CREATION) {
         m_points.clear();
-        m_drawing = false;
     }
     m_canvas->updateCanvas();
 }
@@ -112,168 +109,187 @@
 
 void KisToolPerspectiveGrid::mousePressEvent(KoPointerEvent *event)
 {
-    KisPerspectiveGrid* pGrid = m_canvas->view()->resourceProvider()->currentImage()->perspectiveGrid();
-    if (!pGrid->hasSubGrids() && m_mode != MODE_CREATION) { // it's possible that the perspectiv grid was cleared
-        m_mode = MODE_CREATION;
-        m_points.clear();
-    }
-    if (m_mode == MODE_CREATION && event->button() == Qt::LeftButton) {
-        m_drawing = true;
-        m_currentPt = event->point;
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
 
-        if (m_points.isEmpty()) {
-            m_points.append(m_currentPt);
-            m_isFirstPoint = true;
-        } else {
-            m_isFirstPoint = false;
+        setMode(KisTool::PAINT_MODE);
+
+        KisPerspectiveGrid* pGrid = m_canvas->view()->resourceProvider()->currentImage()->perspectiveGrid();
+        if (!pGrid->hasSubGrids() && m_internalMode != MODE_CREATION) { // it's possible that the perspectiv grid was cleared
+            m_internalMode = MODE_CREATION;
+            m_points.clear();
         }
-        m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
-    } else if (m_mode == MODE_EDITING && event->button() == Qt::LeftButton) {
-        // Look for the handle which was pressed
-        QPointF mousep = m_canvas->viewConverter()->documentToView(event->point);
-        for (QList<KisSubPerspectiveGrid*>::const_iterator it = pGrid->begin(); it != pGrid->end(); ++it) {
-            KisSubPerspectiveGrid* grid = *it;
-            QPointF gridCenter = grid->center();
-            dbgKrita << "click at " << event->point << " top left at " << *grid->topLeft();
-            if (m_selectedNode1 = nodeNearPoint(grid, mousep)) {
-                m_mode = MODE_DRAGING_NODE;
-                break;
-            } else if (mouseNear(mousep, ((pixelToView(*grid->topLeft()) + pixelToView(*grid->bottomLeft()))*0.5))) {
-                dbgPlugins << " PRESS LEFT HANDLE";
-                m_mode = MODE_DRAGING_TRANSLATING_TWONODES;
-                m_selectedNode1 = new KisPerspectiveGridNode(*grid->topLeft());
-                m_selectedNode2 = new KisPerspectiveGridNode(*grid->bottomLeft());
-                KisSubPerspectiveGrid* newsubgrid = new KisSubPerspectiveGrid(m_selectedNode1, grid->topLeft() , grid->bottomLeft(), m_selectedNode2);
-                m_dragEnd = convertToPixelCoord(event->point);
-                pGrid->addNewSubGrid(newsubgrid);
-                m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
-                break;
-            } else if (mouseNear(mousep, ((pixelToView(*grid->topRight()) + pixelToView(*grid->bottomRight()))*0.5))) {
-                dbgPlugins << " PRESS RIGHT HANDLE";
-                m_mode = MODE_DRAGING_TRANSLATING_TWONODES;
-                m_selectedNode1 = new KisPerspectiveGridNode(*grid->topRight());
-                m_selectedNode2 = new KisPerspectiveGridNode(*grid->bottomRight());
-                KisSubPerspectiveGrid* newsubgrid = new KisSubPerspectiveGrid(grid->topRight(), m_selectedNode1, m_selectedNode2, grid->bottomRight());
-                m_dragEnd = convertToPixelCoord(event->point);
-                pGrid->addNewSubGrid(newsubgrid);
-                m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
-                break;
-            } else if (mouseNear(mousep, ((pixelToView(*grid->topLeft()) + pixelToView(*grid->topRight()))*0.5))) {
-                dbgPlugins << " PRESS TOP HANDLE";
-                m_mode = MODE_DRAGING_TRANSLATING_TWONODES;
-                m_selectedNode1 = new KisPerspectiveGridNode(*grid->topLeft());
-                m_selectedNode2 = new KisPerspectiveGridNode(*grid->topRight());
-                KisSubPerspectiveGrid* newsubgrid = new KisSubPerspectiveGrid(m_selectedNode1, m_selectedNode2,  grid->topRight(), grid->topLeft());
-                m_dragEnd = convertToPixelCoord(event->point);
-                pGrid->addNewSubGrid(newsubgrid);
-                m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
-                break;
-            } else if (mouseNear(mousep, ((pixelToView(*grid->bottomLeft()) + pixelToView(*grid->bottomRight()))*0.5))) {
-                dbgPlugins << " PRESS BOTTOM HANDLE";
-                m_mode = MODE_DRAGING_TRANSLATING_TWONODES;
-                m_selectedNode1 = new KisPerspectiveGridNode(*grid->bottomLeft());
-                m_selectedNode2 = new KisPerspectiveGridNode(*grid->bottomRight());
-                KisSubPerspectiveGrid* newsubgrid = new KisSubPerspectiveGrid(grid->bottomLeft(), grid->bottomRight(), m_selectedNode2, m_selectedNode1);
-                m_dragEnd = convertToPixelCoord(event->point);
-                pGrid->addNewSubGrid(newsubgrid);
-                m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
-                break;
-            } else if (pixelToView(QRectF((gridCenter.x() - 16), (gridCenter.y() - 16), 32, 32)).contains(mousep)) {
-                dbgPlugins << " PRESS DELETE ICON";
-                pGrid->deleteSubGrid(grid);
-                m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
-                if (!pGrid->hasSubGrids()) {
-                    m_mode = MODE_CREATION;
-                    useCursor(KisCursor::load("tool_perspectivegrid_cursor.png", 6, 6));
-                    m_points.clear();
+        if (m_internalMode == MODE_CREATION) {
+            m_currentPt = event->point;
+
+            if (m_points.isEmpty()) {
+                m_points.append(m_currentPt);
+                m_isFirstPoint = true;
+            } else {
+                m_isFirstPoint = false;
+            }
+            m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+        } else if (m_internalMode == MODE_EDITING) {
+            // Look for the handle which was pressed
+            QPointF mousep = m_canvas->viewConverter()->documentToView(event->point);
+            for (QList<KisSubPerspectiveGrid*>::const_iterator it = pGrid->begin(); it != pGrid->end(); ++it) {
+                KisSubPerspectiveGrid* grid = *it;
+                QPointF gridCenter = grid->center();
+                dbgKrita << "click at " << event->point << " top left at " << *grid->topLeft();
+                if (m_selectedNode1 = nodeNearPoint(grid, mousep)) {
+                    m_internalMode = MODE_DRAGING_NODE;
+                    break;
+                } else if (mouseNear(mousep, ((pixelToView(*grid->topLeft()) + pixelToView(*grid->bottomLeft()))*0.5))) {
+                    dbgPlugins << " PRESS LEFT HANDLE";
+                    m_internalMode = MODE_DRAGING_TRANSLATING_TWONODES;
+                    m_selectedNode1 = new KisPerspectiveGridNode(*grid->topLeft());
+                    m_selectedNode2 = new KisPerspectiveGridNode(*grid->bottomLeft());
+                    KisSubPerspectiveGrid* newsubgrid = new KisSubPerspectiveGrid(m_selectedNode1, grid->topLeft() , grid->bottomLeft(), m_selectedNode2);
+                    m_dragEnd = convertToPixelCoord(event->point);
+                    pGrid->addNewSubGrid(newsubgrid);
+                    m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+                    break;
+                } else if (mouseNear(mousep, ((pixelToView(*grid->topRight()) + pixelToView(*grid->bottomRight()))*0.5))) {
+                    dbgPlugins << " PRESS RIGHT HANDLE";
+                    m_internalMode = MODE_DRAGING_TRANSLATING_TWONODES;
+                    m_selectedNode1 = new KisPerspectiveGridNode(*grid->topRight());
+                    m_selectedNode2 = new KisPerspectiveGridNode(*grid->bottomRight());
+                    KisSubPerspectiveGrid* newsubgrid = new KisSubPerspectiveGrid(grid->topRight(), m_selectedNode1, m_selectedNode2, grid->bottomRight());
+                    m_dragEnd = convertToPixelCoord(event->point);
+                    pGrid->addNewSubGrid(newsubgrid);
+                    m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+                    break;
+                } else if (mouseNear(mousep, ((pixelToView(*grid->topLeft()) + pixelToView(*grid->topRight()))*0.5))) {
+                    dbgPlugins << " PRESS TOP HANDLE";
+                    m_internalMode = MODE_DRAGING_TRANSLATING_TWONODES;
+                    m_selectedNode1 = new KisPerspectiveGridNode(*grid->topLeft());
+                    m_selectedNode2 = new KisPerspectiveGridNode(*grid->topRight());
+                    KisSubPerspectiveGrid* newsubgrid = new KisSubPerspectiveGrid(m_selectedNode1, m_selectedNode2,  grid->topRight(), grid->topLeft());
+                    m_dragEnd = convertToPixelCoord(event->point);
+                    pGrid->addNewSubGrid(newsubgrid);
+                    m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+                    break;
+                } else if (mouseNear(mousep, ((pixelToView(*grid->bottomLeft()) + pixelToView(*grid->bottomRight()))*0.5))) {
+                    dbgPlugins << " PRESS BOTTOM HANDLE";
+                    m_internalMode = MODE_DRAGING_TRANSLATING_TWONODES;
+                    m_selectedNode1 = new KisPerspectiveGridNode(*grid->bottomLeft());
+                    m_selectedNode2 = new KisPerspectiveGridNode(*grid->bottomRight());
+                    KisSubPerspectiveGrid* newsubgrid = new KisSubPerspectiveGrid(grid->bottomLeft(), grid->bottomRight(), m_selectedNode2, m_selectedNode1);
+                    m_dragEnd = convertToPixelCoord(event->point);
+                    pGrid->addNewSubGrid(newsubgrid);
+                    m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+                    break;
+                } else if (pixelToView(QRectF((gridCenter.x() - 16), (gridCenter.y() - 16), 32, 32)).contains(mousep)) {
+                    dbgPlugins << " PRESS DELETE ICON";
+                    pGrid->deleteSubGrid(grid);
+                    m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+                    if (!pGrid->hasSubGrids()) {
+                        m_internalMode = MODE_CREATION;
+                        useCursor(KisCursor::load("tool_perspectivegrid_cursor.png", 6, 6));
+                        m_points.clear();
+                    }
+                    break;
                 }
-                break;
             }
         }
+
+
     }
+    else {
+        KisTool::mousePressEvent(event);
+    }
 }
 
 
 void KisToolPerspectiveGrid::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (m_mode == MODE_CREATION) {
-        if (!m_points.isEmpty()) {
-            // get current mouse position
-            m_currentPt = event->point;
-            // draw new lines on canvas
-            m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
+        if (m_internalMode == MODE_CREATION) {
+            if (!m_points.isEmpty()) {
+                // get current mouse position
+                m_currentPt = event->point;
+                // draw new lines on canvas
+                m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+            }
+        } else {
+            if (m_internalMode == MODE_DRAGING_NODE) {
+                QPointF pos = convertToPixelCoord(event);
+                m_selectedNode1->setX(pos.x());
+                m_selectedNode1->setY(pos.y());
+                m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+            }
+            if (m_internalMode == MODE_DRAGING_TRANSLATING_TWONODES) {
+                QPointF translate = convertToPixelCoord(event->point) - m_dragEnd;
+                m_dragEnd = convertToPixelCoord(event->point);
+                *m_selectedNode1 += translate;;
+                *m_selectedNode2 += translate;;
+                m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+            }
         }
-    } else {
-        if (m_mode == MODE_DRAGING_NODE) {
-            QPointF pos = convertToPixelCoord(event);
-            m_selectedNode1->setX(pos.x());
-            m_selectedNode1->setY(pos.y());
-            m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+        bool wasHiglightedNode = m_higlightedNode != 0;
+        QPointF mousep = m_canvas->viewConverter()->documentToView(event->point);
+        KisPerspectiveGrid* pGrid = m_canvas->view()->resourceProvider()->currentImage()->perspectiveGrid();
+        for (QList<KisSubPerspectiveGrid*>::const_iterator it = pGrid->begin(); it != pGrid->end(); ++it) {
+            KisSubPerspectiveGrid* grid = *it;
+            if (m_higlightedNode = nodeNearPoint(grid, mousep)) {
+                if (m_higlightedNode == m_selectedNode1 || m_higlightedNode == m_selectedNode2) {
+                    m_higlightedNode = 0;
+                } else {
+                    m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+                    break;
+                }
+            }
         }
-        if (m_mode == MODE_DRAGING_TRANSLATING_TWONODES) {
-            QPointF translate = convertToPixelCoord(event->point) - m_dragEnd;
-            m_dragEnd = convertToPixelCoord(event->point);
-            *m_selectedNode1 += translate;;
-            *m_selectedNode2 += translate;;
+        if (wasHiglightedNode && !m_higlightedNode) {
             m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
         }
     }
-    bool wasHiglightedNode = m_higlightedNode != 0;
-    QPointF mousep = m_canvas->viewConverter()->documentToView(event->point);
-    KisPerspectiveGrid* pGrid = m_canvas->view()->resourceProvider()->currentImage()->perspectiveGrid();
-    for (QList<KisSubPerspectiveGrid*>::const_iterator it = pGrid->begin(); it != pGrid->end(); ++it) {
-        KisSubPerspectiveGrid* grid = *it;
-        if (m_higlightedNode = nodeNearPoint(grid, mousep)) {
-            if (m_higlightedNode == m_selectedNode1 || m_higlightedNode == m_selectedNode2) {
-                m_higlightedNode = 0;
-            } else {
-                m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
-                break;
-            }
-        }
+    else {
+        KisTool::mouseMoveEvent(event);
     }
-    if (wasHiglightedNode && !m_higlightedNode) {
-        m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
-    }
 }
 
 void KisToolPerspectiveGrid::mouseReleaseEvent(KoPointerEvent *event)
 {
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
 
-    if (m_mode == MODE_CREATION) {
-        if (m_drawing && event->button() == Qt::LeftButton && !m_isFirstPoint)  {
-            m_points.append(m_currentPt);
-            if (m_points.size() == 4) { // wow we have a grid, isn't that cool ?
-                m_canvas->view()->resourceProvider()->currentImage()->perspectiveGrid()->addNewSubGrid(
-                    new KisSubPerspectiveGrid(
-                        new KisPerspectiveGridNode(convertToPixelCoord(m_points[0])),
-                        new KisPerspectiveGridNode(convertToPixelCoord(m_points[1])),
-                        new KisPerspectiveGridNode(convertToPixelCoord(m_points[2])),
-                        new KisPerspectiveGridNode(convertToPixelCoord(m_points[3]))));
-                m_canvas->view()->perspectiveGridManager()->setVisible(true);
-                m_mode = MODE_EDITING;
-                useCursor(KisCursor::arrowCursor());
+        if (m_internalMode == MODE_CREATION) {
+            if (!m_isFirstPoint)  {
+                m_points.append(m_currentPt);
+                if (m_points.size() == 4) { // wow we have a grid, isn't that cool ?
+                    m_canvas->view()->resourceProvider()->currentImage()->perspectiveGrid()->addNewSubGrid(
+                        new KisSubPerspectiveGrid(
+                            new KisPerspectiveGridNode(convertToPixelCoord(m_points[0])),
+                            new KisPerspectiveGridNode(convertToPixelCoord(m_points[1])),
+                            new KisPerspectiveGridNode(convertToPixelCoord(m_points[2])),
+                            new KisPerspectiveGridNode(convertToPixelCoord(m_points[3]))));
+                    m_canvas->view()->perspectiveGridManager()->setVisible(true);
+                    m_internalMode = MODE_EDITING;
+                    useCursor(KisCursor::arrowCursor());
+                }
             }
-        }
-        m_drawing = false;
-        m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
-    } else {
-        m_mode = MODE_EDITING;
-        // Check if there is a need for merging two nodes
-        if (m_higlightedNode && m_selectedNode2 == 0) {
-            m_higlightedNode->mergeWith(m_selectedNode1);
             m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+        } else {
+            m_internalMode = MODE_EDITING;
+            // Check if there is a need for merging two nodes
+            if (m_higlightedNode && m_selectedNode2 == 0) {
+                m_higlightedNode->mergeWith(m_selectedNode1);
+                m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+            }
+            m_selectedNode1 = 0;
+            m_selectedNode2 = 0;
         }
-        m_selectedNode1 = 0;
-        m_selectedNode2 = 0;
     }
-
+    else {
+        KisTool::mouseReleaseEvent(event);
+    }
 }
 
 void KisToolPerspectiveGrid::paint(QPainter& gc, const KoViewConverter &converter)
 {
     Q_UNUSED(converter);
-    if (m_mode == MODE_CREATION) {
+    if (m_internalMode == MODE_CREATION) {
         drawGridCreation(gc);
     } else {
         drawGrid(gc);
Index: plugins/tools/tool_perspectivegrid/kis_tool_perspectivegrid.h
===================================================================
--- plugins/tools/tool_perspectivegrid/kis_tool_perspectivegrid.h	(revision 1177751)
+++ plugins/tools/tool_perspectivegrid/kis_tool_perspectivegrid.h	(working copy)
@@ -72,14 +72,13 @@
 protected:
     QPointF m_dragEnd;
 
-    bool m_drawing;
     bool m_isFirstPoint;
     QPointF m_currentPt;
 private:
     typedef QVector<QPointF> QPointFVector;
 
     QPointFVector m_points;
-    PerspectiveGridEditionMode m_mode;
+    PerspectiveGridEditionMode m_internalMode;
     qint32 m_handleSize, m_handleHalfSize;
     KisPerspectiveGridNodeSP m_selectedNode1, m_selectedNode2, m_higlightedNode;
     KisCanvas2* m_canvas;
